Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QGradient

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.gui.QGradient

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

Direct Known Subclasses:
  QConicalGradient, QLinearGradient, QRadialGradient

    public abstract class QGradient

extends QtJambiObject
implements java.lang.Cloneable

The `QGradient` class is used in combination with `QBrush` to specify gradient fills. Qt currently supports three types of gradient fills:

- Linear gradients interpolate colors between start and end points.
- Radial gradients interpolate colors between a focal point and end points on a circle surrounding it.
- Conical gradients interpolate colors around a center point.

A gradient's type can be retrieved using the `type()` function. Each of the types is represented by a subclass of `QGradient`:

`QLinearGradient` | `QRadialGradient` | `QConicalGradient`
--- | --- | ---

The colors in a gradient is defined using stop points of the QGradientStop type, i.e. a position and a color. Use the `setColorAt()` function to define a single stop point. Alternatively, use the `setStops()` function to define several stop points in one go. Note that the latter function replaces the current set of stop points.

It is the gradient's complete set of stop points (accessible through the `stops()` function) that describes how the gradient area should be filled. If no stop points have been specified, a gradient of black at 0 to white at 1 is used.

A diagonal linear gradient from black at (100, 100) to white at (200, 200) could be specified like this:

            QLinearGradient linearGrad = new QLinearGradient(new QPointF(100, 100),
                                                             new QPointF(200, 200));
            linearGrad.setColorAt(0, new QColor(Qt.GlobalColor.black));
            linearGrad.setColorAt(1, new QColor(Qt.GlobalColor.white));

A gradient can have an arbitrary number of stop points. The following would create a radial gradient starting with red in the center, blue and then green on the edges:

            QRadialGradient radialGrad =
                new QRadialGradient(new QPointF(100, 100), 100);
            radialGrad.setColorAt(0, new QColor(Qt.GlobalColor.red));
            radialGrad.setColorAt(0.5, new QColor(Qt.GlobalColor.blue));
            radialGrad.setColorAt(1, new QColor(Qt.GlobalColor.green));

It is possible to repeat or reflect the gradient outside its area by specifiying the `spread method` using the `setSpread()` function. The default is to pad the outside area with the color at the closest stop point. The currently set `spread method` can be retrieved using the `spread()` function. The `QGradient::Spread` enum defines three different methods:

`PadSpread` | `RepeatSpread` | `ReflectSpread`

Note that the `setSpread()` function only has effect for linear and radial gradients. The reason is that the conical gradient is closed by definition, i.e. the conical gradient fills the entire circle from 0 - 360 degrees, while the boundary of a radial or a linear gradient can be specified through its radius or final stop points, respectively.

The gradient coordinates can be specified in logical coordinates, relative to device coordinates, or relative to object bounding box coordinates. The `coordinate mode` can be set using the `setCoordinateMode()` function. The default is `LogicalMode` , where the gradient coordinates are specified in the same way as the object coordinates. To retrieve the currently set `coordinate mode` use `coordinateMode()`.

See also:
  The Gradients Demo, and `QBrush`.

Nested Class Summary
`static class` | `QGradient.CoordinateMode` This enum specifies how gradient coordinates map to the paint device on which the gradient is used.
`static class` | `QGradient.Spread` Specifies how the area outside the gradient area should be filled.
`static class` | `QGradient.Type`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Method Summary
`QGradient` | `clone()` This method is reimplemented for internal reasons
`QGradient.CoordinateMode` | `coordinateMode()` Returns the coordinate mode of this gradient.
`static QGradient` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QGradient instance pointed to by `nativePointer`.
`static QNativePointer` | `nativePointerArray(QGradient[] array)` This function returns a QNativePointer that is pointing to the specified QGradient array.
`void` | `setColorAt(double pos, QColor color)` Creates a stop point at the given `position` with the given `color`.
`void` | `setCoordinateMode(QGradient.CoordinateMode mode)` Sets the coordinate mode of this gradient to `mode`.
`void` | `setSpread(QGradient.Spread spread)` Specifies the spread `method` that should be used for this gradient.
`void` | `setStops(java.util.List stops)` Replaces the current set of stop points with the given `stops`.
`QGradient.Spread` | `spread()` Returns the spread method use by this gradient.
`java.util.List` | `stops()` Returns the stop points for this gradient.
`QGradient.Type` | `type()` Returns the type of gradient.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Method Detail

### coordinateMode

    public final QGradient.CoordinateMode coordinateMode()

  Returns the coordinate mode of this gradient. The default mode is `LogicalMode` .

See also:
  `setCoordinateMode()`.

### setColorAt

    public final void setColorAt(double pos,
                                 QColor color)

  Creates a stop point at the given `position` with the given `color`. The given `position` must be in the range 0 to 1.

See also:
  `setStops()`, and `stops()`.

### setCoordinateMode

    public final void setCoordinateMode(QGradient.CoordinateMode mode)

  Sets the coordinate mode of this gradient to `mode`. The default mode is `LogicalMode` .

See also:
  `coordinateMode()`.

### setSpread

    public final void setSpread(QGradient.Spread spread)

  Specifies the spread `method` that should be used for this gradient.

  Note that this function only has effect for linear and radial gradients.

See also:
  `spread()`.

### setStops

    public final void setStops(java.util.List stops)

  Replaces the current set of stop points with the given `stops`. The positions of the points must be in the range 0 to 1, and must be sorted with the lowest point first.

### spread

    public final QGradient.Spread spread()

  Returns the spread method use by this gradient. The default is `PadSpread` .

See also:
  `setSpread()`.

### stops

    public final java.util.List stops()

  Returns the stop points for this gradient.

  If no stop points have been specified, a gradient of black at 0 to white at 1 is used.

See also:
  `setStops()`, and `setColorAt()`.

### type

    public final QGradient.Type type()

  Returns the type of gradient.

### fromNativePointer

    public static QGradient fromNativePointer(QNativePointer nativePointer)

  This method returns the QGradient instance pointed to by `nativePointer`.

### nativePointerArray

    public static QNativePointer nativePointerArray(QGradient[] array)

  This function returns a QNativePointer that is pointing to the specified QGradient array.

### clone

    public QGradient clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD